/**
    First, LAST Name: Alexandru GHITA
    School: National College Andrei Saguna
    Contest #2, Senior-3
    Input file: lisp.in
    Output is on the screen
**/

#include <cstdio>
#include <cstring>

using namespace std;

/*
ADD = 1
DIV = 2
EXP = 3
MULT = 4
SQR = 5
SUB = 6
*/

struct sublist
{
    int op, nr_arg = 0, arg[50];
} A[50];

int main_op, nr_sublist;

int operator_type(char s[])
{
    if (strcmp("ADD", s) == 0)
        return 1;
    if (strcmp("DIV", s) == 0)
        return 2;
    if (strcmp("EXP", s) == 0)
        return 3;
    if (strcmp("MULT", s) == 0)
        return 4;
    if (strcmp("SQR", s) == 0)
        return 5;
    if (strcmp("SUB", s) == 0)
        return 6;
    return 0;
}

void read_expression()
{
    char s[50], c;
    memset(s, 0, sizeof(s));

    scanf("%c", &c);
    scanf("%s", s);
    main_op = operator_type(s);

    do
    {
        scanf("%c", &c);
        if (c == ' ')
        {
            scanf("%c", &c);
            memset(s, 0, sizeof(s));
            scanf("%s", s);
            A[++nr_sublist].op = operator_type(s);
            do
            {
                scanf("%c", &c);
                if (c == ')')
                    break;
                scanf("%d", &A[nr_sublist].arg[++A[nr_sublist].nr_arg]);
            }while (c != ')');
        }
    }while (c != '\n');
}

void print_sublist(int nr)
{
    printf("(");
    if (A[nr].op == 1)
        printf("ADD");
    if (A[nr].op == 2)
        printf("DIV");
    if (A[nr].op == 3)
        printf("EXP");
    if (A[nr].op == 4)
        printf("MULT");
    if (A[nr].op == 5)
        printf("SQR");
    if (A[nr].op == 6)
        printf("SUB");
    for (int i = 1; i <= A[nr].nr_arg; ++i)
        printf(" %d", A[nr].arg[i]);
    printf(")");
}

void op_count()
{
    printf("%d\n", nr_sublist);
}

void op_remove(int J, int K)
{
    printf("(");
    if (main_op == 1)
        printf("ADD");
    else if (main_op == 2)
        printf("DIV");
    else if (main_op == 3)
        printf("EXP");
    else if (main_op == 4)
        printf("MULT");
    else if (main_op == 5)
        printf("SQR");
    else if (main_op == 6)
        printf("SUB");

    for (int i = 1; i <= nr_sublist; ++i)
    {
        if (J <= i && i <= K)
            continue;
        printf(" ");
        print_sublist(i);
    }
    printf(")\n");
}

void op_sort(int J, int K)
{
    printf("(");
    if (main_op == 1)
        printf("ADD");
    else if (main_op == 2)
        printf("DIV");
    else if (main_op == 3)
        printf("EXP");
    else if (main_op == 4)
        printf("MULT");
    else if (main_op == 5)
        printf("SQR");
    else if (main_op == 6)
        printf("SUB");

    for (int i = 1; i < J; ++i)
    {
        printf(" ");
        print_sublist(i);
    }
    for (int type = 1; type <= 6; ++type)
        for (int i = J; i <= K; ++i)
            if (A[i].op == type)
            {
                printf(" ");
                print_sublist(i);
            }
    for (int i = K + 1; i <= nr_sublist; ++i)
    {
        printf(" ");
        print_sublist(i);
    }
    printf(")\n");
}

void op_reverse(int J, int K)
{
    printf("(");
    if (main_op == 1)
        printf("ADD");
    else if (main_op == 2)
        printf("DIV");
    else if (main_op == 3)
        printf("EXP");
    else if (main_op == 4)
        printf("MULT");
    else if (main_op == 5)
        printf("SQR");
    else if (main_op == 6)
        printf("SUB");

    for (int i = 1; i < J; ++i)
    {
        printf(" ");
        print_sublist(i);
    }
    for (int i = K; i >= J; --i)
    {
        printf(" ");
        print_sublist(i);
    }
    for (int i = K + 1; i <= nr_sublist; ++i)
    {
        printf(" ");
        print_sublist(i);
    }
    printf(")\n");
}

void op_maximum()
{
    int maximum = 0, imax = 0;
    for (int i = 1; i <= nr_sublist; ++i)
        if (A[i].nr_arg > maximum)
        {
            maximum = A[i].nr_arg;
            imax = i;
        }
    print_sublist(imax);
    printf("\n");
}

void solve()
{
    char cmd[50], c;
    int l1 = 0, l2 = 0;

    memset(cmd, 0, sizeof(cmd));
    scanf("%s", cmd);
    if (strcmp("COUNT", cmd) == 0)
        op_count();
    else if (strcmp("REMOVE", cmd) == 0)
    {
        scanf("%d %d", &l1, &l2);
        op_remove(l1, l2);
    }
    else if (strcmp("SORT", cmd) == 0)
    {
        scanf("%d %d", &l1, &l2);
        op_sort(l1, l2);
    }
    else if (strcmp("REVERSE", cmd) == 0)
    {
        scanf("%d %d", &l1, &l2);
        op_reverse(l1, l2);
    }
    else if (strcmp("MAXIMUM", cmd) == 0)
    {
        op_maximum();
    }
    scanf("%c", &c);
}

int main()
{
    freopen("lisp.in", "r", stdin);

    read_expression();

    for (int line = 1; line <= 5; ++line)
        solve();

    return 0;
}
