/**
First, LAST Name: Florin Ovidiu FRATILA
Contest #3 Senior-3
School: National College Andrei Saguna
Input file: isola.in
Output is on the screen
*/
#include <iostream>
#include <algorithm>
#include <vector>
#include <cstdio>
#include <cstdlib>

using namespace std;

int board[10][10],values_board[10][10];

void prep_board()
{
    for(int i=1;i<=7;++i)
        for(int j=1;j<=7;++j)
            board[i][j]=0;
    for(int i=0;i<=8;++i)
        board[i][0]=board[i][8]=board[0][i]=board[8][i]=1;
}

void print_board()
{
    for(int i=0;i<=8;++i)
    {
        for(int j=0;j<=8;++j)
            cout<<board[i][j];
        cout<<"\n";
    }
    cout<<"\n\n\n\n\n\n";
}

int geti(int pos)
{
    if(pos%7==0)
        return pos/7;
    return pos/7+1;
}

int getj(int pos)
{
    if(pos%7==0)
        return 7;
    return pos%7;
}

int main()
{
    freopen("isola.in","r",stdin);
    vector<pair<int,int> > tiles;
    for(int i=1;i<=7;++i)
        for(int j=1;j<=7;++j)
            if(j%7)
                values_board[i][j]=(i-1)*7+j%7;
            else
                values_board[i][j]=(i-1)*7+7;
    for(int iline=1;iline<=5;++iline)
    {
        int p1_pos,p2_pos,pos;
        int p1i,p1j,p2i,p2j;
        cin>>p1_pos>>p2_pos;

        p1i=geti(p1_pos);
        p2i=geti(p2_pos);
        p1j=getj(p1_pos);
        p2j=getj(p2_pos);
        prep_board();
        board[p1i][p1j]=1;
        board[p2i][p2j]=1;

        do
        {
            cin>>pos;
            board[geti(pos)][getj(pos)]=1;
        }
        while(pos!=0);

        int m,mi[]={-1,-1,-1,0,1,1,1,0},mj[]={-1,0,1,1,1,0,-1,-1};
        int tomovei,tomovej;

        for(m=0;m<8;++m)
            if(board[p1i+mi[m]][p1j+mj[m]]==0)//player 1 can move there
            {
                tomovei=p1i+mi[m];
                tomovej=p1j+mj[m];
                break;
            }
        if(tomovei==p2i)//move horizontally
        {
            if(tomovej<p2j)
            {
                --p2j;
                while(p2j>=0&&board[p2i][p2j]==0)
                {
                    tiles.push_back(make_pair(p2i,p2j));
                    board[p2i][p2j]=1;
                    --p2j;
                }
            }
            else
            {
                ++p2j;
                while(p2j<=8&&board[p2i][p2j]==0)
                {
                    tiles.push_back(make_pair(p2i,p2j));
                    board[p2i][p2j]=1;
                    ++p2j;
                }
            }
        }
        else if(tomovej==p2j)//move vertically
        {
            if(tomovei<p2i)
            {
                --p2i;
                while(p2i>=0&&board[p2i][p2j]==0)
                {
                    tiles.push_back(make_pair(p2i,p2j));
                    board[p2i][p2j]=1;
                    --p2i;
                }
            }
            else
            {
                ++p2i;
                while(p2i<=8&&board[p2i][p2j]==0)
                {
                    tiles.push_back(make_pair(p2i,p2j));
                    board[p2i][p2j]=1;
                    ++p2i;
                }
            }
        }
        else if(abs(tomovei-p2i)==abs(tomovej-p2j))//move diagonally
        {
            if(tomovei<p2i)//upwards
            {
                if(tomovej>p2j)//to the right
                {
                    --p2i;++p2j;
                    while(p2i>=0&&board[p2i][p2j]==0)
                    {
                        tiles.push_back(make_pair(p2i,p2j));
                        board[p2i][p2j]=1;
                        --p2i;++p2j;
                    }
                }
                else          //to the left
                {
                    --p2i;--p2j;
                    while(p2i>=0&&board[p2i][p2j]==0)
                    {
                        tiles.push_back(make_pair(p2i,p2j));
                        board[p2i][p2j]=1;
                        --p2i;--p2j;
                    }
                }
            }
            else
            {
                if(tomovej>p2j)//to the right
                {
                    ++p2i;++p2j;
                    while(p2i<=8&&board[p2i][p2j]==0)
                    {
                        tiles.push_back(make_pair(p2i,p2j));
                        board[p2i][p2j]=1;
                        ++p2i;++p2j;
                    }
                }
                else          //to the left
                {
                    ++p2i;--p2j;
                    while(p2i<=8&&board[p2i][p2j]==0)
                    {
                        tiles.push_back(make_pair(p2i,p2j));
                        board[p2i][p2j]=1;
                        ++p2i;--p2j;
                    }
                }
            }
        }
        else//no move to block that space
        {
            cout<<"NONE\n";
            continue;
        }

        for(m=0;m<8;++m)
            if(board[p1i+mi[m]][p1j+mj[m]]==0)
            {
                cout<<"NONE\n";
                goto end;
            }
        for(vector<pair<int,int> >::iterator it=tiles.begin();it!=tiles.end();++it)
            cout<<values_board[it->first][it->second]<<" ";
        cout<<"\n";

        end:
            tiles.clear();
    }
    return 0;
}
