/**
    First, LAST Name: Alexandru GHITA
    School: National College "Andrei Saguna"
    Senior 3, Contest #3
    Input file: isola.in
    Output is on the screen
**/

#include <cstdio>
#include <cstring>

using namespace std;

const int stepx[8] = {-1, -1, 0, 1, 1, 1, 0, -1},
          stepy[8] = {0, 1, 1, 1, 0, -1, -1, -1};

bool done;
int marker1, marker2, m1x, m1y, m2x, m2y, board[10][10], aux_board[10][10], removed_tiles[50];

void cleanup()
{
    done = false;
    marker1 = marker2 = 0;
    m1x = m1y = m2x = m2y = 0;
    memset(board, 0, sizeof(board));
    memset(aux_board, 0, sizeof(aux_board));
    memset(removed_tiles, 0, sizeof(removed_tiles));
}

void mark_on_board(int cell, int value)
{
    int x, y;

    if (cell % 7 == 0)
    {
        x = cell / 7;
        y = 7;
    }
    else
    {
        x = cell / 7 + 1;
        y = cell % 7;
    }

    board[x][y] = value;

    if (value == -1)
        return;

    if (value == 1)
    {
        m1x = x;
        m1y = y;
    }
    else if (value == 2)
    {
        m2x = x;
        m2y = y;
    }
}

void read()
{
    int cell;

    scanf("%d %d", &marker1, &marker2);
    mark_on_board(marker1, 1);
    mark_on_board(marker2, 2);

    do
    {
        scanf("%d", &cell);
        if (cell == 0)
            break;
        mark_on_board(cell, -1);
    }while (cell != 0);
}

bool cell_is_valid(int x, int y)
{
    if (1 <= x && x <= 7 && 1 <= y && y <= 7 && aux_board[x][y] == 0)
        return true;
    return false;
}

int get_cell_value(int x, int y)
{
    int value = (x - 1) * 7;

    if (y % 7 == 0)
        value += 7;
    else
        value += y % 7;

    return value;
}

void move_in_direction(int direction, int cx, int cy)
{
    memset(removed_tiles, 0, sizeof(removed_tiles));

    while (cell_is_valid(cx + stepx[direction], cy + stepy[direction]))
    {
        cx += stepx[direction];
        cy += stepy[direction];
        aux_board[cx][cy] = 2;
        removed_tiles[++removed_tiles[0]] = get_cell_value(cx, cy);
    }
}

bool check_if_blocked(int x, int y)
{
    bool ok = false;

    for (int i = 0; i <= 7; ++i)
        if (cell_is_valid(x + stepx[i], y + stepy[i]))
            return false;
    for (int i = 0; i <= 7; ++i)
        if (aux_board[x + stepx[i]][y + stepy[i]] == 2)
            ok = true;
    return ok;
}

void solve()
{
    for (int i = 0; i <= 7; ++i)
    {
        memcpy(aux_board, board, sizeof(board));
        move_in_direction(i, m2x, m2y);
        done = (done || check_if_blocked(m1x, m1y));
        if (done == true)
            break;
    }
}

void print()
{
    if (done == false)
    {
        printf("NONE\n");
        return;
    }

    for (int i = 1; i <= removed_tiles[0]; ++i)
        printf("%d ", removed_tiles[i]);
    printf("\n");
}

int main()
{
    freopen("isola.in", "r", stdin);

    for (int line = 1; line <= 5; ++line)
    {
        cleanup();
        read();
        solve();
        print();
    }

    return 0;
}
