/**
First LAST Name: Gabriel Robert INELUS
School: National College Andrei Saguna
Contest #3 Senior 3
Input file: isola.in
Output is on the screen!
*/

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>

using namespace std;
int m[60][60];
int used[60][60];
pair<int,int> st,ed;
const int dx[10]={ 0,0, 1,1,1,-1,-1,-1},
          dy[10]={-1,1,-1,0,1,-1, 0, 1};
vector<pair<int,int> > vecini,road;

int get_poz(int x,int y){
    return 7*(7-x) + y;
}
pair<int,int> get_coord(int pz){
    int pzx,pzy;
    pzx = (pz - 1)/7 + 1;
    pzy = (pz - 1)%7 + 1;
    pzx = 8 - pzx;
    return make_pair(pzx,pzy);
}

void prepare(){
    for(int i = 1; i <= 7; ++i)
        for(int j = 1; j <= 7; ++j)
            m[i][j] = get_poz(i,j);
}

void make_used(){
    memset(used,0,sizeof(used)); /// we clear the table
    for(int i = 0; i <= 8; ++i)
    {
        used[0][i] = 1; /// board the table so we don't get out
        used[8][i] = 1;
        used[i][0] = 1;
        used[i][8] = 1;
    }
}

void Read(){
    int N,M;
    scanf("%d%d",&N,&M);
    ed = get_coord(N); /// ending point
    st = get_coord(M); /// starting point
    used[st.first][st.second] = 1; /// we mark the tiles as removed
    used[ed.first][ed.second] = 1;

    int x;
    scanf("%d",&x);
    while(x){
        pair<int,int> crd = get_coord(x);
        used[crd.first][crd.second] = 1; /// dead cell
        scanf("%d",&x);
    }
}

int parcurge(int x,int y,int k){
    int _x,_y;
    _x = x + dx[k];
    _y = y + dy[k];
    while(!used[_x][_y]) /// while the new point is available ( not blocked neither boundary )
    {
        x = _x; /// advance to new position
        y = _y;
        road.push_back(make_pair(x,y)); /// we save the road cells
        _x = x + dx[k];/// prepare new positions
        _y = y + dy[k];
    }
    for(vector<pair<int,int> > ::iterator it = vecini.begin(); it != vecini.end(); ++it)
        for(vector<pair<int,int> > ::iterator jt = road.begin(); jt != road.end(); ++jt)
            if(*it == *jt) /// if one of the removed tiels is also a neighbour of the end point
                return 1; /// then we have blocked one possible move
    return 0;/// we couldn't block any available neighbour
}

void solve(){
    int _ax,_ay;
    for(int i = 0; i <= 7; ++i) /// we get every neighbour of the end point
    {
        _ax = ed.first + dx[i];
        _ay = ed.second + dy[i];
        if(!used[_ax][_ay])
            vecini.push_back(make_pair(_ax,_ay));/// we get the neighbours
    }
    int ok = 0;
    for(int i = 0; i < 8; ++i)
    {
        ok = parcurge(st.first,st.second,i); /// we try each type of linear search
        if(ok == 0) /// if we didn't block a neighbour we clear the road
            road.clear();
        if(ok == 1) /// we blocked a neighbour
            break;
    }
    if(ok == 1)
    {///we print the road
        for(int i = 0; i < road.size(); ++i)
            printf("%d ",get_poz(road[i].first,road[i].second));
        printf("\n");
        road.clear();
    }
    else
        printf("NONE\n");/// no roads that block a neighbour of the ending point
    vecini.clear();
}

int main()
{
    freopen("isola.in","r",stdin);

    prepare();
    for(int tst = 1; tst <= 5; ++tst)
    {
        make_used();
        Read();
        solve();
    }
    return 0;
}
